var __assign=Object.assign||function(t){for(var i,e=1,n=arguments.length;e<n;e++){i=arguments[e];for(var r in i)Object.prototype.hasOwnProperty.call(i,r)&&(t[r]=i[r])}return t};function invariant(t,i){if(!t)throw new Error(i)}function withDefault(t,i){return void 0!==t&&null!==t?t:i}var Spring=function(){function t(t){void 0===t&&(t={}),this._listeners=[],this._currentAnimationStep=0,this._currentTime=0,this._springTime=0,this._currentValue=0,this._currentVelocity=0,this._isAnimating=!1,this._oscillationVelocityPairs=[],this._config={fromValue:withDefault(t.fromValue,0),toValue:withDefault(t.toValue,1),stiffness:withDefault(t.stiffness,100),damping:withDefault(t.damping,10),mass:withDefault(t.mass,1),initialVelocity:withDefault(t.initialVelocity,0),overshootClamping:withDefault(t.overshootClamping,!1),allowsOverdamping:withDefault(t.allowsOverdamping,!1),restVelocityThreshold:withDefault(t.restVelocityThreshold,.001),restDisplacementThreshold:withDefault(t.restDisplacementThreshold,.001)},this._currentValue=this._config.fromValue,this._currentVelocity=this._config.initialVelocity}return t.prototype.start=function(){var t=this,i=this._config,e=i.fromValue,n=i.toValue,r=i.initialVelocity;return e===n&&0===r||(this._reset(),this._isAnimating=!0,this._currentAnimationStep||(this._notifyListeners("onStart"),this._currentAnimationStep=requestAnimationFrame(function(i){t._step(Date.now())}))),this},t.prototype.stop=function(){return this._isAnimating?(this._isAnimating=!1,this._notifyListeners("onStop"),this._currentAnimationStep&&(cancelAnimationFrame(this._currentAnimationStep),this._currentAnimationStep=0),this):this},Object.defineProperty(t.prototype,"currentValue",{get:function(){return this._currentValue},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"currentVelocity",{get:function(){return this._currentVelocity},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isAtRest",{get:function(){return this._isSpringAtRest()},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isAnimating",{get:function(){return this._isAnimating},enumerable:!0,configurable:!0}),t.prototype.updateConfig=function(t){this._advanceSpringToTime(Date.now());var i={fromValue:this._currentValue,initialVelocity:this._currentVelocity};return this._config=__assign({},this._config,i,t),this._reset(),this},t.prototype.onStart=function(t){return this._listeners.push({onStart:t}),this},t.prototype.onUpdate=function(t){return this._listeners.push({onUpdate:t}),this},t.prototype.onStop=function(t){return this._listeners.push({onStop:t}),this},t.prototype.removeListener=function(t){return this._listeners=this._listeners.reduce(function(i,e){return-1!==Object.values(e).indexOf(t)||i.push(e),i},[]),this},t.prototype.removeAllListeners=function(){return this._listeners=[],this},t.prototype._reset=function(){this._currentTime=Date.now(),this._springTime=0,this._currentValue=this._config.fromValue,this._currentVelocity=this._config.initialVelocity},t.prototype._notifyListeners=function(t){var i=this;this._listeners.forEach(function(e){var n=e[t];"function"==typeof n&&n(i)})},t.prototype._step=function(t){var i=this;this._advanceSpringToTime(t,!0),this._isAnimating&&(this._currentAnimationStep=requestAnimationFrame(function(t){return i._step(Date.now())}))},t.prototype._advanceSpringToTime=function(i,e){if(void 0===e&&(e=!1),this._isAnimating){var n=i-this._currentTime;n>t.MAX_DELTA_TIME_MS&&(n=t.MAX_DELTA_TIME_MS),this._springTime+=n;var r=this._config.damping,s=this._config.mass,o=this._config.stiffness,a=this._config.fromValue,h=this._config.toValue,u=-this._config.initialVelocity;invariant(s>0,"Mass value must be greater than 0"),invariant(o>0,"Stiffness value must be greater than 0"),invariant(r>0,"Damping value must be greater than 0");var c=r/(2*Math.sqrt(o*s)),l=Math.sqrt(o/s)/1e3,f=l*Math.sqrt(1-c*c),p=l*Math.sqrt(c*c-1),_=h-a;c>1&&!this._config.allowsOverdamping&&(c=1);var g=0,m=0,y=this._springTime;if(c<1)g=h-(V=Math.exp(-c*l*y))*((u+c*l*_)/f*Math.sin(f*y)+_*Math.cos(f*y)),m=c*l*V*(Math.sin(f*y)*(u+c*l*_)/f+_*Math.cos(f*y))-V*(Math.cos(f*y)*(u+c*l*_)-f*_*Math.sin(f*y));else if(1===c){g=h-(V=Math.exp(-l*y))*(_+(u+l*_)*y),m=V*(u*(y*l-1)+y*_*(l*l))}else{var V;g=h-(V=Math.exp(-c*l*y))*((u+c*l*_)*Math.sinh(p*y)+p*_*Math.cosh(p*y))/p,m=V*c*l*(Math.sinh(p*y)*(u+c*l*_)+_*p*Math.cosh(p*y))/p-V*(p*Math.cosh(p*y)*(u+c*l*_)+p*p*_*Math.sinh(p*y))/p}if(this._currentTime=i,this._currentValue=g,this._currentVelocity=m,e&&(this._notifyListeners("onUpdate"),this._isAnimating))return this._isSpringOvershooting()||this._isSpringAtRest()?(0!==o&&(this._currentValue=h,this._currentVelocity=0,this._notifyListeners("onUpdate")),void this.stop()):void 0}},t.prototype._isSpringOvershooting=function(){var t=this._config,i=t.stiffness,e=t.fromValue,n=t.toValue,r=!1;return t.overshootClamping&&0!==i&&(r=e<n?this._currentValue>n:this._currentValue<n),r},t.prototype._isSpringAtRest=function(){var t=this._config,i=t.stiffness,e=t.toValue,n=t.restDisplacementThreshold,r=t.restVelocityThreshold,s=Math.abs(this._currentVelocity)<=r;return 0!==i&&Math.abs(e-this._currentValue)<=n&&s},t.MAX_DELTA_TIME_MS=1/60*1e3*4,t}();export{Spring};
//# sourceMappingURL=wobble.es.js.map
